/*
 * Created on 2004/11/01
 */
package com.wdpress.vol24.fileupload;

import java.io.IOException;
import java.io.InputStream;
import java.util.Iterator;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.DiskFileUpload;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUpload;
import org.apache.commons.fileupload.FileUploadException;

/**
 * @author iochi
 */
public class FileUploadServlet extends HttpServlet {

    /**
     * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest,
     * javax.servlet.http.HttpServletResponse)
     */
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException {
        // vt@CAbv[hł邩`FbN
        if (!FileUpload.isMultipartContent(req)) {
            res.sendError(HttpServletResponse.SC_BAD_REQUEST);
            return;
        }
        // ͂̏
        DiskFileUpload upload = new DiskFileUpload();
        Iterator items = null;
        try {
            // ͂̎s
            items = upload.parseRequest(req).iterator();
        } catch (FileUploadException e) {
            throw new ServletException(e);
        }
        // 11FORMȉo
        while (items.hasNext()) {
            FileItem item = (FileItem) items.next();
            if (item.isFormField()) {
                // ʏFORMf[^̏ꍇ
                String name = item.getFieldName(); // FORMiname
                String value = item.getString(); // ͂ꂽl
            } else {
                // t@C̏ꍇ
                String fieldName = item.getFieldName(); // FORMiname
                String fileName = item.getName(); // t@C
                String contentType = item.getContentType(); // Content-Type
                long sizeInBytes = item.getSize(); // t@CTCY
                // t@C̓ẽXg[擾
                InputStream uploadedStream = item.getInputStream();
                // ...(ȗ) f[^̒gQƂ铙
                uploadedStream.close();
                // Abv[ht@C傫
                // e|[t@CłĂ邩Ȃ̂ō폜Ăł
                item.delete();
            }
        }
    }
}