/*
 * Created on 2004/09/10
 */
package com.wdpress.vol24.jfreechart;

import java.io.File;
import java.io.IOException;

import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.data.DefaultPieDataset;
import org.jfree.data.PieDataset;

/**
 * @author iochi
 */
public class CreatePieChart {

    /**
     * @ ~Ot̉摜t@C𐶐܂B
     * @throws IOException t@C̐ɎsB
     */
    public void createChartImageFile() throws IOException {
        // ~Ot쐬
        PieDataset dataset = createDataset();
        JFreeChart chart = createChart(dataset);

        // 쐬~Ot摜t@Cɂ
        final File file = new File("chart.png");
        ChartUtilities.saveChartAsPNG(file, chart, 600, 400);
    }

    /**
     * A ~Ot̃f[^Zbg𐶐܂B
     * @return ~Ot̃f[^Zbg
     */
    private PieDataset createDataset() {
        // ~Otp̃f[^ZbgIuWFNg쐬
        DefaultPieDataset defaultpiedataset = new DefaultPieDataset();
        // f[^ݒ
        // f[^̈Ӗ\L[ƐlyAɂ
        defaultpiedataset.setValue("", 43.200000000000003D);
        defaultpiedataset.setValue("", 10D);
        defaultpiedataset.setValue("哤", 27.5D);
        defaultpiedataset.setValue("Ƃ낱", 17.5D);
        defaultpiedataset.setValue("WKC", 11D);
        defaultpiedataset.setValue("Tc}C", 19.399999999999999D);
        return defaultpiedataset;
    }

    /**
     * B ~Ot𐶐܂B
     * @param piedataset ~Ot̃f[^ZbgB
     * @return ~OtB
     */
    private JFreeChart createChart(PieDataset piedataset) {
        // f[^Zbgw肵ĉ~Ot𐶐
        return ChartFactory.createPieChart("Sample", piedataset, true, true,
            false);
    }
}