/*
 * Created on 2004/10/28
 */
package com.wdpress.vol24.lucene;

import java.io.IOException;

import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.ja.JapaneseAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.queryParser.ParseException;
import org.apache.lucene.queryParser.QueryParser;
import org.apache.lucene.search.Hits;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;

/**
 * @author iochi
 */
public class KeywordQuery {

    /**
     * L[[h܂B
     * @param path ̏ꏊB
     * @param keyword L[[hB
     * @throws IOException ɎsꍇB
     * @throws ParseException L[[h̉͂ɎsꍇB
     */
    public void keywordQuery(String path, String keyword) throws IOException,
        ParseException {
        // @ {PɕIuWFNg𐶐
        Analyzer analyzer = new JapaneseAnalyzer();

        // A QuerIuWFNg쐬
        Query query = QueryParser.parse(keyword, null, analyzer);

        // B 
        IndexSearcher searcher = new IndexSearcher(path);
        Hits hits = searcher.search(query);

        // C ʂ̎擾
        for (int i = 0; i < hits.length(); i++) {
            Document doc = hits.doc(i);
            String key = doc.get("key"); // DB̎L[擾
        }

        // D ʂ̎擾
        searcher.close();
    }
}