/*
 * Created on 2004/11/06
 */
package com.wdpress.vol24.rss4j;

import java.io.File;

import churchillobjects.rss4j.RssChannel;
import churchillobjects.rss4j.RssChannelItem;
import churchillobjects.rss4j.RssDocument;
import churchillobjects.rss4j.generator.RssGenerator;

/**
 * @author iochi
 */
public class CreateRss {

    /**
     * RSSt@C쐬܂B
     * @throws Exception sB
     */
    public void createRss() throws Exception {
        // @ RSShLg𐶐
        RssDocument doc = new RssDocument();
        doc.setVersion(RssDocument.VERSION_10);

        // A Channel쐬
        RssChannel channel = new RssChannel();
        channel.setChannelTitle("Title");
        channel.setChannelLink("http://www.sunicom.co.jp/");
        channel.setChannelDescription("Description");
        doc.addChannel(channel);

        // B ChannelItemǉ
        RssChannelItem item1 = new RssChannelItem();
        item1.setItemTitle("Foo news");
        item1.setItemLink("http://www.churchillobjects.com/c/11028.html");
        item1.setItemDescription("News description");
        channel.addItem(item1);

        // C RSShLgt@Cɂ
        File file = new File("rss.xml");
        RssGenerator.generateRss(doc, file);
    }
}